﻿using MapFinder.Data;
using MapFinder.Utility;
using Microsoft.VisualBasic.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace MapFinder
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            InitInstance();
        }

        private void InitInstance()
        {
            wbMain.WebBrowser.ScriptErrorsSuppressed = true;
            wbMain.WebBrowser.Navigate("https://map.naver.com/");
        }

        private double[] ConvertToEPSG3857(double lat, double lng)
        {
            var x = (lng * 20037508.34) / 180;
            var y = Math.Log(Math.Tan(((90 + lat) * Math.PI) / 360)) / (Math.PI / 180);
            y = (y * 20037508.34) / 180;
            return new double[] { x, y };
        }

        private void btnFind_Click(object sender, RoutedEventArgs e)
        {
            List<FoundLocale> localeList = KakaoAPI.Search(tbQuery.Text);
            lbxFound.ItemsSource = localeList;
        }

        private void lbxFound_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (lbxFound.SelectedIndex == -1)
                return;

            FoundLocale selected = lbxFound.SelectedItem as FoundLocale;
            if (selected == null)
                return;

            double[] epsg3857 = ConvertToEPSG3857(selected.Lat, selected.Lng);
            string url = $"http://map.naver.com/v5/search?c={epsg3857[0]},{epsg3857[1]},{17},0,0,0,dh";

            //string url = $"https://google.co.kr/maps/@{selected.Lat},{selected.Lng},11z";
            //string url = $"https://map.kakao.com/link/map/{selected.Name},{selected.Lat},{selected.Lng}";
            //Uri uri = new Uri(url);
            //wbMain.Source = uri;

            wbMain.WebBrowser.Navigate(url);
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            //System.Windows.Forms.WebBrowser webBrowser = new System.Windows.Forms.WebBrowser();
            //webBrowser.ScriptErrorsSuppressed = true;
            //wfhWebBrowser.Child = webBrowser;
            //webBrowser.Navigate("https://map.kakao.com");
        }
    }
}
